#include "plugin.h"
#include <commctrl.h>

#define FILE_EXIST(X) (GetFileAttributes(X)==0xFFFFFFFF ? FALSE : TRUE)

BOOL OnInit();
void OnQuit();
void OnTrackChange();
void OnStatusChange();
void OnConfig();

FITTLE_PLUGIN_INFO fpi = {
	PDK_VER,
	OnInit,
	OnQuit,
	OnTrackChange,
	OnStatusChange,
	OnConfig,
	NULL,
	NULL
};

static HWND hLV;

/* Gg|g */
BOOL WINAPI _DllMainCRTStartup(HANDLE hModule, DWORD dwFunction, LPVOID lpNot){
    return TRUE;
}

/* NɈxĂ΂܂ */
BOOL OnInit(){
	LVBKIMAGE lvbki;
	char szPath[MAX_PATH];
	int nLen;

	CoInitialize(NULL);

	nLen = GetModuleFileName(fpi.hDllInst, szPath, MAX_PATH);
	lstrcpy(&szPath[nLen-3], "bmp");

	if(!FILE_EXIST(szPath)){
		CoUninitialize();
		return FALSE;
	}

	ZeroMemory(&lvbki, sizeof(LVBKIMAGE));
	lvbki.ulFlags = LVBKIF_SOURCE_URL | LVBKIF_STYLE_TILE;
	lvbki.pszImage = szPath;

	hLV = (HWND)SendMessage(fpi.hParent, WM_FITTLE, GET_LISTVIEW, 0);

	ListView_SetBkImage(hLV, &lvbki);
	ListView_SetTextBkColor(hLV, CLR_NONE);

	return TRUE;
}

/* IɈxĂ΂܂ */
void OnQuit(){
	LVBKIMAGE lvbki;

	// wiɖ߂ȂƗ
	ZeroMemory(&lvbki, sizeof(LVBKIMAGE));
	lvbki.ulFlags = LVBKIF_SOURCE_NONE;
	ListView_SetBkImage(hLV, &lvbki);

	CoUninitialize();
	return;
}

/* Ȃς鎞ɌĂ΂܂ */
void OnTrackChange(){
	return;
}

/* ĐԂς鎞ɌĂ΂܂ */
void OnStatusChange(){
	return;
}

/* ݒʂĂяo܂ij*/
void OnConfig(){
	return;
}

#ifdef __cplusplus
extern "C"
{
#endif
__declspec(dllexport) FITTLE_PLUGIN_INFO *GetPluginInfo(){
	return &fpi;
}
#ifdef __cplusplus
}
#endif